Index: /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15017)
@@ -573,5 +573,5 @@
       };
 
-      var simplerProgram = Simplifier.Simplify(program, evaluator);
+      var simplerProgram = Simplifier.Simplify(program, pool.PushConfiguration, evaluator);
 
       Console.WriteLine(simplerProgram);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15017)
@@ -6,7 +6,4 @@
   using System.Reflection;
   using System.Text.RegularExpressions;
-  using HeuristicLab.BenchmarkSuite.Problems;
-
-  using Microsoft.VisualBasic.FileIO;
 
 
@@ -33,4 +30,31 @@
     protected abstract Example ParseExample(string[] input, string[] output);
 
+    //private IEnumerable<Example> ParseData() {
+    //  using (var file = GetType().Assembly.GetManifestResourceStream(InstanceArchiveName))
+    //  using (var archive = new ZipArchive(file, ZipArchiveMode.Read)) {
+    //    var entry = archive.Entries.SingleOrDefault(x => x.Name == FileName);
+
+    //    using (var parser = new TextFieldParser(entry.Open())) {
+    //      parser.TextFieldType = FieldType.Delimited;
+    //      parser.SetDelimiters(ExampleFieldDelimiter);
+    //      parser.HasFieldsEnclosedInQuotes = true;
+    //      parser.TrimWhiteSpace = false;
+
+    //      //Processing rows
+    //      while (!parser.EndOfData) {
+    //        var fields = parser.ReadFields();
+
+    //        if (fields.Length != InputArgumentCount + OutputArgumentCount)
+    //          throw new InvalidDataException("Number of values do not fit");
+
+    //        var input = fields.Take(InputArgumentCount).ToArray();
+    //        var output = fields.Skip(InputArgumentCount).ToArray();
+
+    //        yield return ParseExample(input, output);
+    //      }
+    //    }
+    //  }
+    //}
+
     private IEnumerable<Example> ParseData() {
       using (var file = GetType().Assembly.GetManifestResourceStream(InstanceArchiveName))
@@ -38,19 +62,10 @@
         var entry = archive.Entries.SingleOrDefault(x => x.Name == FileName);
 
-        using (var parser = new TextFieldParser(entry.Open())) {
-          parser.TextFieldType = FieldType.Delimited;
-          parser.SetDelimiters(ExampleFieldDelimiter);
-          parser.HasFieldsEnclosedInQuotes = true;
-          parser.TrimWhiteSpace = false;
+        using (var reader = new StreamReader(entry.Open())) {
+          var lines = CsvParser.Parse(reader, ',', '"');
 
-          //Processing rows
-          while (!parser.EndOfData) {
-            var fields = parser.ReadFields();
-
-            if (fields.Length != InputArgumentCount + OutputArgumentCount)
-              throw new InvalidDataException("Number of values do not fit");
-
-            var input = fields.Take(InputArgumentCount).ToArray();
-            var output = fields.Skip(InputArgumentCount).ToArray();
+          foreach (var line in lines) {
+            var input = line.Take(InputArgumentCount).ToArray();
+            var output = line.Skip(InputArgumentCount).ToArray();
 
             yield return ParseExample(input, output);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/CsvParser.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/CsvParser.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/CsvParser.cs	(revision 15017)
@@ -0,0 +1,100 @@
+﻿/*
+ * License: CPOL
+ * Source: https://www.codeproject.com/Tips/823670/Csharp-Light-and-Fast-CSV-Parser
+ * Author: Yuriy Magurdumov
+ */
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.BenchmarkSuite {
+  using System.IO;
+
+  public static class CsvParser {
+    private static Tuple<T, IEnumerable<T>> HeadAndTail<T>(this IEnumerable<T> source) {
+      if (source == null)
+        throw new ArgumentNullException("source");
+      var en = source.GetEnumerator();
+      en.MoveNext();
+      return Tuple.Create(en.Current, EnumerateTail(en));
+    }
+
+    private static IEnumerable<T> EnumerateTail<T>(IEnumerator<T> en) {
+      while (en.MoveNext()) yield return en.Current;
+    }
+
+    public static IEnumerable<IList<string>> Parse(string content, char delimiter, char qualifier) {
+      using (var reader = new StringReader(content))
+        return Parse(reader, delimiter, qualifier);
+    }
+
+    public static Tuple<IList<string>, IEnumerable<IList<string>>> ParseHeadAndTail(TextReader reader, char delimiter, char qualifier) {
+      return HeadAndTail(Parse(reader, delimiter, qualifier));
+    }
+
+    public static IEnumerable<IList<string>> Parse(TextReader reader, char delimiter, char qualifier) {
+      var inQuote = false;
+      var record = new List<string>();
+      var sb = new StringBuilder();
+
+      while (reader.Peek() != -1) {
+        var readChar = (char)reader.Read();
+
+        if (readChar == '\n' || (readChar == '\r' && (char)reader.Peek() == '\n')) {
+          // If it's a \r\n combo consume the \n part and throw it away.
+          if (readChar == '\r')
+            reader.Read();
+
+          if (inQuote) {
+            if (readChar == '\r')
+              sb.Append('\r');
+            sb.Append('\n');
+          } else {
+            if (record.Count > 0 || sb.Length > 0) {
+              record.Add(sb.ToString());
+              sb.Clear();
+            }
+
+            if (record.Count > 0)
+              yield return record;
+
+            record = new List<string>(record.Count);
+          }
+        } else if (sb.Length == 0 && !inQuote) {
+          if (readChar == qualifier)
+            inQuote = true;
+          else if (readChar == delimiter) {
+            record.Add(sb.ToString());
+            sb.Clear();
+          //} else if (char.IsWhiteSpace(readChar)) { // Ignore leading whitespace
+          } else
+            sb.Append(readChar);
+        } else if (readChar == delimiter) {
+          if (inQuote)
+            sb.Append(delimiter);
+          else {
+            record.Add(sb.ToString());
+            sb.Clear();
+          }
+        } else if (readChar == qualifier) {
+          if (inQuote) {
+            if ((char)reader.Peek() == qualifier) {
+              reader.Read();
+              sb.Append(qualifier);
+            } else
+              inQuote = false;
+          } else
+            sb.Append(readChar);
+        } else
+          sb.Append(readChar);
+      }
+
+      if (record.Count > 0 || sb.Length > 0)
+        record.Add(sb.ToString());
+
+      if (record.Count > 0)
+        yield return record;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Example.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Example.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Example.cs	(revision 15017)
@@ -1,3 +1,4 @@
 ﻿namespace HeuristicLab.BenchmarkSuite {
+  using System;
 
   using HeuristicLab.Common;
@@ -40,4 +41,6 @@
       OutputStringVector = emptyStringVectors;
       OutputPrint = string.Empty;
+      OutputFloatPrecision = 15;
+      OutputFloatVectorPrecision = 15;
     }
 
@@ -67,4 +70,6 @@
       OutputPrint = origin.OutputPrint;
       OutputPrintLineCount = origin.OutputPrintLineCount;
+      OutputFloatPrecision = origin.OutputFloatPrecision;
+      OutputFloatVectorPrecision = origin.OutputFloatVectorPrecision;
     }
 
@@ -115,7 +120,23 @@
     public string[][] OutputStringVector { get; set; }
     [Storable]
-    public string OutputPrint { get; set; }
+    private string outputPrint;
+    private static readonly string[] NewLineSeparator = { "\r\n", "\n" };
+    public string OutputPrint
+    {
+      get { return outputPrint; }
+      set
+      {
+        outputPrint = value;
+        OutputPrintLineCount = value != null ? value.Split(NewLineSeparator, StringSplitOptions.None).Length : 0;
+      }
+    }
+
     [Storable]
-    public int OutputPrintLineCount { get; set; }
+    public int OutputPrintLineCount { get; private set; }
+
+    [Storable]
+    public int OutputFloatPrecision { get; set; }
+    [Storable]
+    public int OutputFloatVectorPrecision { get; set; }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentConverter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentConverter.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentConverter.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public static double[] ConvertDoubles(string input) {
-      return ConvertMultiple(input, str => double.Parse(str, CultureInfo.InvariantCulture));
+      return ConvertMultiple(input, str => double.Parse(str, NumberStyles.Float, CultureInfo.InvariantCulture));
     }
 
@@ -36,5 +36,28 @@
 
     public static string[] ConvertStringVector(string input) {
-      return ConvertMultiple(input, s => s.Trim('\"'));
+      var length = input.Length - 1;
+      var strs = new List<string>();
+
+      for (var i = 1; i < length; i++) {
+        // collect string
+        var c = input[i];
+
+        if (c == ' ') continue;
+        if (c != '\"') throw new InvalidDataException("Unable to parse string vector");
+
+        var start = i + 1;
+        do {
+          i++;
+          c = input[i];
+        } while (i < length - 1  &&
+               !(c == '\"' && input[i + 1] == ' ') &&
+               !(i == length - 2 && c == '\"' && input[i + 1] == ']'));
+
+
+        var str = input.Substring(start, i - start);
+        strs.Add(str);
+      }
+
+      return strs.ToArray();
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 15017)
@@ -105,4 +105,5 @@
     <Compile Include="BenchmarkSuiteDataDescriptor.cs" />
     <Compile Include="BenchmarkSuiteInstanceProvider.cs" />
+    <Compile Include="CsvParser.cs" />
     <Compile Include="DataTypes.cs" />
     <Compile Include="Problems\ScrabbleScore.cs" />
@@ -141,4 +142,5 @@
     <Compile Include="Problems\WordStats.cs" />
     <Compile Include="Problems\XWordLines.cs" />
+    <Compile Include="ProblemType.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Views\ViewHelper.cs" />
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15017)
@@ -10,7 +10,9 @@
   public class ProblemData : NamedItem {
 
-    public ProblemData() {
+    public ProblemData(ProblemType problemType) {
       Name = "BenchmarkSuite Problem Data";
       ErcOptions = new ErcOptions(); // default does nothing
+      FloatStringFormat = "R";
+      ProblemType = problemType;
     }
 
@@ -31,5 +33,9 @@
       EnabledDataTypes = origin.EnabledDataTypes;
       ErcOptions = cloner.Clone(origin.ErcOptions);
+      FloatStringFormat = origin.FloatStringFormat;
     }
+
+    [Storable]
+    public readonly ProblemType ProblemType;
 
     [Storable]
@@ -71,4 +77,7 @@
     public ErcOptions ErcOptions { get; set; }
 
+    [Storable]
+    public string FloatStringFormat { get; set; }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new ProblemData(this, cloner);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemType.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemType.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemType.cs	(revision 15017)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite {
+  public enum ProblemType : uint {
+    Checksum,
+    CollatzNumbers,
+    CompareStringLengths,
+    CountOdds,
+    Digits,
+    DoubleLetters,
+    EvenSquares,
+    ForLoopIndex,
+    Grades,
+    LastIndexOfZero,
+    Median,
+    MirrorImage,
+    NegativeToZero,
+    NumberIO,
+    PigLatin,
+    ReplaceSpaceWithNewline,
+    ScrabbleScore,
+    Smallest,
+    SmallOrLarge,
+    StringDifferences,
+    StringLengthsBackwards,
+    SumOfSquares,
+    SuperAnagrams,
+    Syllables,
+    VectorAverage,
+    VectorSummed,
+    WallisPi,
+    WordStats,
+    XWordLines,
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.Checksum) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CollatzNumbers.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CollatzNumbers.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CollatzNumbers.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.CollatzNumbers) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CompareStringLengths.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CompareStringLengths.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CompareStringLengths.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.CompareStringLengths) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.CountOdds) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Digits.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Digits.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Digits.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.Digits) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/DoubleLetters.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/DoubleLetters.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/DoubleLetters.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.DoubleLetters) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/EvenSquares.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/EvenSquares.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/EvenSquares.cs	(revision 15017)
@@ -12,5 +12,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.EvenSquares) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ForLoopIndex.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ForLoopIndex.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ForLoopIndex.cs	(revision 15017)
@@ -16,5 +16,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.ForLoopIndex) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Grades.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Grades.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Grades.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.Grades) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/LastIndexOfZero.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/LastIndexOfZero.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/LastIndexOfZero.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.LastIndexOfZero) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Median.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Median.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Median.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.Median) {
         Name = Name,
         Description = Description,
@@ -21,8 +21,8 @@
         WorstResult = 100,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer },
-        OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
+        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
         TrainingCount = 100,
         TestCount = 1000,
-        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean,
+        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.Print,
         MaxSize = 200,
         EvalLimit = 200,
@@ -30,6 +30,5 @@
           ErcProbability = 0.05,
           IntegerErcOptions = new IntegerErcOptions(
-            new IntegerConstantErc(0),
-            new IntegerRangeErc(-1000, 100))
+            new IntegerRangeErc(-100, 100))
         }
       };
@@ -41,5 +40,5 @@
         OutputArgs = output,
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input),
-        OutputInteger = ExampleArgumentConverter.ConvertIntegers(output[0]),
+        OutputPrint = output[0]
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/MirrorImage.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/MirrorImage.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/MirrorImage.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.MirrorImage) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NegativeToZero.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NegativeToZero.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NegativeToZero.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.NegativeToZero) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15017)
@@ -1,3 +1,5 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Globalization;
+
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Float;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
@@ -15,5 +17,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.NumberIO) {
         Name = Name,
         Description = Description,
@@ -22,5 +24,5 @@
         WorstResult = 400,
         InputArgumentTypes = new[] { ExampleArgumentType.Float, ExampleArgumentType.Integer },
-        OutputArgumentTypes = new[] { ExampleArgumentType.Float },
+        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
         TrainingCount = 25,
         TestCount = 1000,
@@ -39,4 +41,5 @@
 
     protected override Example ParseExample(string[] input, string[] output) {
+      var estimedFloatValue = double.Parse(output[0], CultureInfo.InvariantCulture);
       return new Example {
         InputArgs = input,
@@ -44,6 +47,6 @@
         InputFloat = ExampleArgumentConverter.ConvertDoubles(input[0]),
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input[1]),
-        OutputFloat = ExampleArgumentConverter.ConvertDoubles(output[0]),
-        //OutputPrint = output[0]
+        //OutputFloat = new[] { estimedFloatValue },
+        OutputPrint = estimedFloatValue.ToString("R", CultureInfo.InvariantCulture),
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/PigLatin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/PigLatin.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/PigLatin.cs	(revision 15017)
@@ -16,5 +16,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.PigLatin) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ReplaceSpaceWithNewline.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ReplaceSpaceWithNewline.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ReplaceSpaceWithNewline.cs	(revision 15017)
@@ -16,5 +16,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.ReplaceSpaceWithNewline) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ScrabbleScore.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ScrabbleScore.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ScrabbleScore.cs	(revision 15017)
@@ -45,5 +45,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.ReplaceSpaceWithNewline) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SmallOrLarge.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SmallOrLarge.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SmallOrLarge.cs	(revision 15017)
@@ -16,5 +16,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.SmallOrLarge) {
         Name = Name,
         Description = Description,
@@ -23,5 +23,5 @@
         WorstResult = 5,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
-        OutputArgumentTypes = new[] { ExampleArgumentType.String },
+        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
         TrainingCount = 100,
         TestCount = 1000,
@@ -44,5 +44,5 @@
         OutputArgs = output,
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input[0]),
-        OutputString = output
+        OutputPrint = output[0]
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Smallest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Smallest.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Smallest.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.Smallest) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringDifferences.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringDifferences.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringDifferences.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.StringDifferences) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringLengthsBackwards.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringLengthsBackwards.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringLengthsBackwards.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.StringDifferences) {
         Name = Name,
         Description = Description,
